﻿//
// WindowsFormsCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;
using System.Data;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace WindowsFormsCSharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // 接続文字列。環境に合わせて修正してください
            string connectionString = "SERVER=LOCALHOST\\SQLEXPRESS;UID=sa2;PWD=sa2;DATABASE=Web";

            // スカラー値関数の場合
            this.ScalarFunction(connectionString);

            // テーブル値関数の場合
            this.TableFunction(connectionString);
        }

        /// <summary>
        /// スカラー値関数を呼ぶ
        /// </summary>
        private void ScalarFunction(string connectionString)
        {
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                // コネクションを開く
                connection.Open();

                // コマンド作成
                SqlCommand command = connection.CreateCommand();

                // SQL
                command.CommandText = "SELECT dbo.ScalarFunction_Sample(@param)";

                // SQLパラメータ設定
                SqlParameter param1 = new SqlParameter("@param", SqlDbType.Int);
                param1.Value = 100;
                command.Parameters.Add(param1);

                // コマンド実行
                object result = command.ExecuteScalar();

                // 結果表示
                MessageBox.Show(result.ToString());
            }
        }

        /// <summary>
        /// テーブル値関数を呼ぶ
        /// </summary>
        private void TableFunction(string connectionString)
        {
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                // コネクションを開く
                connection.Open();

                // コマンド作成
                SqlCommand command = connection.CreateCommand();

                // SQL
                command.CommandText = "SELECT * FROM dbo.TableFunction_Sample()";

                // ストアド プロシージャを実行し、SELECT結果をdataSetへ格納
                DataSet dataSet = new DataSet();
                using (SqlDataAdapter adapter = new SqlDataAdapter(command))
                {
                    adapter.Fill(dataSet);
                }

                // 結果表示
                this.dataGridView1.DataSource = dataSet.Tables[0];
            }
        }
    }
}
